﻿using Syncfusion.XForms.Buttons;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace SupportSample
{

    public class Model
    {
        public string Product { get; set; }

        public int ProductID { get; set; }
    }

    public class ViewModel : INotifyPropertyChanged
    {
        private ObservableCollection<Model> chipItems;


        private ObservableCollection<Model> selectedItems = new ObservableCollection<Model>();

        private ObservableCollection<Model> previouslySelectedItems = new ObservableCollection<Model>();

        public ObservableCollection<Model> PreviouslySelectedItems
        {
            get { return previouslySelectedItems; }
            set
            {
                previouslySelectedItems = value;
                OnPropertyChanged("PreviouslySelectedItems");
            }
        }


        public ObservableCollection<Model> ChipItems
        {
            get { return chipItems; }

            set { chipItems = value; }
        }
        public ObservableCollection<Model> SelectedItems
        {
            get { return selectedItems; }
            set
            {
                selectedItems = value;
                OnPropertyChanged("SelectedItems");
            }

        }

        public ViewModel()
        {
            ChipItems = new ObservableCollection<Model>()
            {
                new Model(){Product="Chip 1",ProductID=1},
                new Model(){Product="Chip 2",ProductID=2},
                new Model(){Product="Chip 3",ProductID=3},
                new Model(){Product="Chip 4",ProductID=4},
                new Model(){Product="Chip 5",ProductID=5},
                new Model(){Product="Chip 6",ProductID=6},
                new Model(){Product="Chip 7",ProductID=7},

            };
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void OnPropertyChanged(string name)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(name));
        }
    }
    public partial class MainPage : ContentPage
    {
        ViewModel viewModel;
        public MainPage()
        {
            InitializeComponent();
            viewModel = new ViewModel();
            this.BindingContext = viewModel;

        }

        private void SfChipGroup_SelectionChanged(object sender, Syncfusion.Buttons.XForms.SfChip.SelectionChangedEventArgs e)
        {
            if (!viewModel.PreviouslySelectedItems.Contains(e.AddedItem) && e.AddedItem != null)
            {
                viewModel.PreviouslySelectedItems.Add(e.AddedItem as Model);
            }
        }
    }
}
